import java.awt.*;
import java.applet.*;
import java.util.*;
import java.awt.event.*;

import Solver;

public final class System extends Applet implements MouseListener, ItemListener {

	/*External tools*/
	Solver solv = new Solver();
	/*Global variables & inits*/
	String init_exp="y1;(1-y0^2)*y1-y0";
	double askelpituus = 0.1;	
	Color nappi = Color.lightGray;
	Font otsikkofontti = new Font("Serif",Font.BOLD,12);
	Color numvari= new Color(0,0,0);
	Color suuntavari= new Color(204,204,255).darker();
	Color asteikkovari= new Color(0,0,0);
	Vector kayrat = new Vector();
	Polygon kayra[] = new Polygon[1];
	Vector faasikayrat = new Vector();
	Polygon faasikayra[] = new Polygon[1];
	int rotaatio = 0;
	int lukuy = 0;
	double talku=0;
	int vpiirto = 0;
	int hpiirto = 1;
	double tmin = -1.0;
	double tmax = 7.0;
	double tleveys = tmax-tmin;
	double ymin = -4.0;
	double ymax = 4.0;
	double yleveys = ymax-ymin;
	double ftmin = -4.0;
	double ftmax = 4.0;
	double ftleveys = ftmax-ftmin;
	double fymin = -4.0;
	double fymax = 4.0;
	double fyleveys = fymax-fymin;
	int leveys = 500;
	int fleveys = 350;
	double alkut = -1;
	double lopput = 7;
	int korkeus = 120;
	int reunus = 25;
	double ypisteet[] = new double[solv.components];
	Label tteksti = new Label("t = ",Label.RIGHT);
	TextField tsyote = new TextField();
	Button piirra = new Button("Draw");
	Button muutat = new Button("Ok");
	Label[] yarvoteksti = new Label[solv.max_comp];
	TextField[] yarvosyote = new TextField[solv.max_comp];
	Label tyhja= new Label("");

	Panel raami = new Panel(new BorderLayout());
	Checkbox[] valitsey = new Checkbox[solv.max_comp];

	Panel kokoraami = new Panel(new BorderLayout());
	Label copyright1 = new Label(" Mika Spra, Simo Kivel",Label.CENTER);
	Label copyright2 = new Label("Institute of Mathematics",Label.CENTER);
	Label copyright3 = new Label("Helsinki University of Technology",Label.CENTER);
	Label copyright4 = new Label("18.04.2001",Label.CENTER);

	Panel copyright = new Panel(new GridLayout(4,1));

	Panel aikaraami = new Panel(new BorderLayout());
  	Piirtoalusta paperi = new Piirtoalusta();
	Faasialusta faasi = new Faasialusta();

	Panel nappiraami1 = new Panel(new BorderLayout());
	Panel nappiraami2 = new Panel(new BorderLayout());
	Panel nappiraami3 = new Panel(new BorderLayout());
	Panel nappiraami4 = new Panel(new BorderLayout());
	Panel nappiraami5 = new Panel(new BorderLayout());

	Panel equationraami = new Panel(new GridLayout(4,1));
	Label equationteksti = new Label("Equation");
	Choice esimerkki = new Choice();
	TextField funktio = new TextField();
	Button luefunktio = new Button("Read equation");

	Panel timeintraami1 = new Panel(new BorderLayout());
	Panel timeintraami2 = new Panel(new GridLayout(1,5));
	Label timeintots = new Label("Time interval");
	Label timeintbeg = new Label("Begin : ",Label.RIGHT);
	Label timeintend = new Label("End : ",Label.RIGHT);
	TextField aikaalku = new TextField();
	TextField aikaloppu = new TextField();
	Button muutajakso = new Button("Change time interval");

	Panel timedepraami1 = new Panel(new BorderLayout());
	Panel timedepraami2 = new Panel(new GridLayout(2,3));
	Panel timedepraami3 = new Panel(new GridLayout(2,1));
	Label aikaots = new Label("Time dependence");
/***********/
	Label tmint = new Label("t min : ",Label.RIGHT);
	Label tmaxt = new Label("t max : ",Label.RIGHT);
	Label ymint = new Label("y min : ",Label.RIGHT);
	Label ymaxt = new Label("y max : ",Label.RIGHT);
/***********/
	TextField tmink = new TextField();
	TextField tmaxk = new TextField();
	TextField ymink = new TextField();
	TextField ymaxk = new TextField();
	Button muutaaika = new Button("Change time scale / Clear");
	
	Panel phaseraami1 = new Panel(new BorderLayout());
	Panel phaseraami2 = new Panel(new GridLayout(3,4));
	Label faasiots = new Label("Phase plane");
	Label tyhja2 = new Label("");
	Label drteksti = new Label("Draw",Label.CENTER);
	Label vteksti = new Label("Vert : ",Label.RIGHT);
	Label hteksti = new Label("Hor : ",Label.RIGHT);
	Choice faasivvalinta = new Choice();
 	Choice faasihvalinta = new Choice();
	Label y0mint = new Label("Min",Label.CENTER);
	Label y0maxt = new Label("Max",Label.CENTER);
	TextField y0min = new TextField();
	TextField y0max = new TextField();
	TextField y1min = new TextField();
	TextField y1max = new TextField();
	Button muutafaasi = new Button("Change phase scale / Clear");
	
	Panel generalraami1 = new Panel(new BorderLayout());
	Panel generalraami3 = new Panel(new GridLayout(1,2));
	Panel generalraami4 = new Panel(new BorderLayout());
	Label generalots = new Label("General");
	Choice algoritmi = new Choice();
	Label askelteksti = new Label("Stepsize : ",Label.RIGHT);
	TextField askel = new TextField();
	Button siivoa=new Button("Clear all");
	TextField lue2 = new TextField();

	Label initialots = new Label("Initial values");

	public void init() {
		setBackground(new Color(204,204,255));
 		int laskin;
		lue2.setBackground(nappi);
		aikaraami.add("South",copyright);
		paperi.setBackground(Color.white);
		paperi.setSize(leveys+reunus*2,korkeus+reunus*2);
		aikaraami.add("Center",paperi);
		kokoraami.add("South",paperi);
		faasi.setBackground(Color.white);
		faasi.setSize(fleveys+reunus*2,fleveys+reunus*2);

		kokoraami.add("Center",faasi);

		equationteksti.setFont(otsikkofontti);
		equationraami.add(equationteksti);
		esimerkki.setBackground(nappi);
		equationraami.add(esimerkki);
		equationraami.add(funktio);
		equationraami.add(luefunktio);
		luefunktio.setBackground(nappi);
		nappiraami1.add("North",equationraami);

		timeintraami2.add(timeintbeg);
		timeintraami2.add(aikaalku);
		timeintraami2.add(timeintend);
		timeintraami2.add(aikaloppu);
		muutajakso.setBackground(nappi);
		timeintots.setFont(otsikkofontti);
		timeintraami1.add("North",timeintots);
		timeintraami1.add("Center",timeintraami2);
		timeintraami1.add("South",muutajakso);
		nappiraami2.add("North",timeintraami1);
		nappiraami1.add("Center",nappiraami2);

		faasiots.setFont(otsikkofontti);
		phaseraami1.add("North",faasiots);
		muutafaasi.setBackground(nappi);
		phaseraami1.add("South",muutafaasi);
		phaseraami2.add(tyhja2);
		phaseraami2.add(drteksti);
		phaseraami2.add(y0mint);
		phaseraami2.add(y0maxt);
		phaseraami2.add(hteksti);
		phaseraami2.add(faasivvalinta);
		phaseraami2.add(y0min);
		phaseraami2.add(y0max);
		phaseraami2.add(vteksti);
		phaseraami2.add(faasihvalinta);
		phaseraami2.add(y1min);
		phaseraami2.add(y1max);
		phaseraami1.add("Center",phaseraami2);
		nappiraami3.add("North",phaseraami1);	
		nappiraami2.add("Center",nappiraami3);
		faasivvalinta.setBackground(nappi);
		faasihvalinta.setBackground(nappi);

		aikaots.setFont(otsikkofontti);
		timedepraami1.add("North",aikaots);
		timedepraami3.add(tmint);
		timedepraami2.add(tmink);
		timedepraami2.add(tmaxt);
		timedepraami2.add(tmaxk);
		timedepraami3.add(ymint);
		timedepraami2.add(ymink);
		timedepraami2.add(ymaxt);
		timedepraami2.add(ymaxk);
		timedepraami1.add("Center",timedepraami2);
		timedepraami1.add("South",muutaaika);
		timedepraami1.add("West",timedepraami3);
		nappiraami4.add("North",timedepraami1);	
		nappiraami3.add("Center",nappiraami4);
		muutaaika.setBackground(nappi);

		generalots.setFont(otsikkofontti);
		generalraami1.add("North",generalots);
		generalraami1.add("Center",algoritmi);
		generalraami4.add("West",askelteksti);
		siivoa.setBackground(nappi);
		generalraami3.add(siivoa);
		generalraami3.add(lue2);
		generalraami4.add("Center",askel);
		algoritmi.setBackground(nappi);
		generalraami4.add("South",generalraami3);
		generalraami1.add("South",generalraami4);
		nappiraami4.add("Center",generalraami1);
		copyright.add(copyright1);
		copyright.add(copyright2);
		copyright.add(copyright3);
		copyright.add(copyright4);
		nappiraami1.add("South",copyright);
		kokoraami.add("East",raami);
		nappiraami5.add("West",kokoraami);
		nappiraami5.add("Center",tyhja);
		nappiraami5.add("East",nappiraami1);
		add(nappiraami5);
		faasivvalinta.add("y0");
		faasihvalinta.add("y1");
		lue2.setEditable(false);		
		solv.parser(init_exp);
		ypisteet = new double[solv.components];
		siivoa.addMouseListener(this);
		paperi.addMouseListener(this);
		muutat.addMouseListener(this);
		piirra.addMouseListener(this);
		muutajakso.addMouseListener(this);
		muutafaasi.addMouseListener(this);
		muutaaika.addMouseListener(this);
		luefunktio.addMouseListener(this);
		faasi.addMouseListener(this);
		esimerkki.addItemListener(this);
		algoritmi.addItemListener(this);
		faasivvalinta.addItemListener(this);
		faasihvalinta.addItemListener(this);
	   	tsyote.setText(""+talku);
		aikaalku.setText(""+alkut);
		aikaloppu.setText(""+lopput);	   
		y0min.setText(""+ftmin);
		y0max.setText(""+ftmax);
		y1min.setText(""+fymin);
		y1max.setText(""+fymax);
		tmink.setText(""+tmin);
		tmaxk.setText(""+tmax);
		ymink.setText(""+ymin);
		ymaxk.setText(""+ymax);
		funktio.setText(init_exp);
		muutaArvoja();
		askel.setBackground(nappi);
		askel.setEditable(false);
		esimerkki.add("Choose");
		esimerkki.add("y1;(1-y0^2)*y1-y0");
		esimerkki.add("y0-2*y0*y1+t;y0-t");
		esimerkki.add("y1;sqrt(1-y0^2)");
		esimerkki.add("y1;-t*y0");
		esimerkki.add("y1;-0.2*y1-sin(y0)");
		esimerkki.add("10*(y1-y0);28*y0-y1-y0*y2;y0*y1-(8/3)*y2");/*Ei tmn pidempi esimerkkej!!!!*/
		/*
		  esimerkki.add("y1;-2/y1-1/y0+cos(t)");
		  esimerkki.add("y1;-y1-sin(y0^2)");
		*/
		algoritmi.add("Adaptive Runge-Kutta");
		algoritmi.add("Euler");
		algoritmi.add("Improved Euler");
		algoritmi.add("Runge-Kutta");
		algoritmi.add("Adams-Bashforth");

	}

 	public final void destroy() {
		try {
			Thread.sleep(2000);
	    } 
		catch(InterruptedException ex) {
	    }

	}
	public final void itemStateChanged(ItemEvent e)  {
 		if (esimerkki.getSelectedItem() != "Choose")
			funktio.setText(esimerkki.getSelectedItem());
		esimerkki.select(0);
		if (algoritmi.getSelectedIndex() == 0){
			askel.setBackground(nappi);
			askel.setText("");
			askel.setEditable(false);
		}
		else {
			askel.setBackground(Color.white);
			askel.setText(""+askelpituus);
			askel.setEditable(true);
		}
		if (solv.components >2) {
			vpiirto = faasivvalinta.getSelectedIndex();
			hpiirto = faasihvalinta.getSelectedIndex();
			faasi.repaint();
		}
	}
	
	public void mousePressed(MouseEvent tapahtuma) {}
	public void mouseEntered(MouseEvent tapahtuma) {}
	public void mouseClicked(MouseEvent tapahtuma) {}
	public final void mouseReleased(MouseEvent tapahtuma) {
		lue2.setText("Wait");
		int laskin;
		double ttesti = 0;
		double y0testi = 0;
		double y1testi = 0;
		boolean ok = true;
		Graphics g = paperi.getGraphics();
		Graphics g2 = faasi.getGraphics();
		if (tapahtuma.getComponent() == siivoa) {
			kayrat.removeAllElements();
			faasikayrat.removeAllElements();
			paperi.repaint();
			faasi.repaint();
			rotaatio=0;
			tsyote.setText(""+talku);
			aikaalku.setText(""+alkut);
			aikaloppu.setText(""+lopput);	   
			y0min.setText(""+ftmin);
			y0max.setText(""+ftmax);
			y1min.setText(""+fymin);
			y1max.setText(""+fymax);
			tmink.setText(""+tmin);
			tmaxk.setText(""+tmax);
			ymink.setText(""+ymin);
			ymaxk.setText(""+ymax);
			lukuy=0;	
		}
		else if (tapahtuma.getComponent() == faasi) {
			if ((solv.components == 2) && (lukuy == 0)) {
				ypisteet[0] = fxMuutosruudulta(tapahtuma.getX());
				ypisteet[1] = fyMuutosruudulta(tapahtuma.getY());
				yarvosyote[0].setText(""+ypisteet[0]);
				yarvosyote[1].setText(""+ypisteet[1]);
				piirraMolemmat();
				lue2.setText("Ready");
			}
		}		
		else if (tapahtuma.getComponent() == paperi) {
			ypisteet[lukuy] = yMuutosruudulta(tapahtuma.getY());
			yarvosyote[lukuy].setText(""+yMuutosruudulta(tapahtuma.getY()));
			g.drawOval(xMuutosruudulle(talku)-5,yMuutosruudulle(ypisteet[lukuy])-5,10,10);
			if (lukuy == solv.components-1) {
				yarvosyote[lukuy].setText(""+yMuutosruudulta(tapahtuma.getY()));
				piirraMolemmat();
				lukuy = 0;
			}
			else lukuy = lukuy+1;
			lue2.setText("Ready");
		}
		else if (tapahtuma.getComponent() == muutat) {
			try {
				ttesti=new Double(tsyote.getText()).doubleValue();
			}
			catch (Exception e) {
				ok = false;
			}
			if (ok) {
				talku = ttesti;
				kayrat.removeAllElements();
				faasikayrat.removeAllElements();
				rotaatio=0;
				faasi.repaint();
				paperi.repaint();
			}
			else {
				tsyote.setText(""+talku);
				getToolkit().beep();
				lue2.setText("Bad value");
			}
		}
		else if (tapahtuma.getComponent() == piirra) {
			for (laskin = 0; laskin < solv.components; laskin++) {
				try {
					y0testi=new Double(yarvosyote[laskin].getText()).doubleValue();
				}
				catch (Exception e) {
					ok = false;
				}
				if (ok) ypisteet[laskin] = y0testi;
			}
			if (ok) {
				piirraMolemmat();
				lue2.setText("Ready");
			}
			else {
				getToolkit().beep();
				lue2.setText("Bad values");
			}
		}
		else if (tapahtuma.getComponent() == muutajakso) {
			try {
				y0testi=new Double(aikaalku.getText()).doubleValue();
				y1testi=new Double(aikaloppu.getText()).doubleValue();
			}
			catch (Exception e) {
				ok = false;
			}
			if ((y0testi > talku) || (y1testi < talku))
				ok = false;
			if (ok) {
				alkut = y0testi;
				lopput = y1testi;
				kayrat.removeAllElements();
				faasikayrat.removeAllElements();
				faasi.repaint();
				paperi.repaint();
				rotaatio=0;				
			}
			else {
				aikaalku.setText(""+alkut);
				aikaloppu.setText(""+lopput);
				getToolkit().beep();
				lue2.setText("Bad values");
			}
		}
		else if (tapahtuma.getComponent() == muutafaasi) {
			faasiMuutos();
			if (solv.components > 2) {
				vpiirto = faasivvalinta.getSelectedIndex();
				hpiirto = faasihvalinta.getSelectedIndex();
			}
				/*kayrat.removeAllElements();*/
				faasikayrat.removeAllElements();
				/*faasi.repaint();*/
				/*paperi.repaint();*/
				/*rotaatio=0;*/
		}
		else if (tapahtuma.getComponent() == muutaaika) {
			aikaMuutos();
			kayrat.removeAllElements();
			/*faasikayrat.removeAllElements();*/
			/*faasi.repaint();*/
			/*paperi.repaint();*/
			/*rotaatio=0;*/
		}
		else if (tapahtuma.getComponent() == luefunktio) {
			if (solv.parser(funktio.getText())) {
				ypisteet = new double[solv.components];
				kayrat.removeAllElements();
				faasikayrat.removeAllElements();
				paperi.repaint();
				faasi.repaint();
				rotaatio=0;				
				faasivvalinta.removeAll();
				faasihvalinta.removeAll();	
				if (solv.components > 2) {
					for (laskin = 0 ; laskin < solv.components; laskin ++) {
						faasivvalinta.add("y"+laskin);
						faasihvalinta.add("y"+laskin);
					}
				}
				if (solv.components == 2) {
					faasivvalinta.add("y0");
					faasihvalinta.add("y1");
				}
				else {
					faasivvalinta.select(0);				 			
					faasihvalinta.select(1);
				}
	 			vpiirto = 0;
	 			hpiirto = 1;	
				phaseraami2.validate();			 			
				muutaArvoja();
			}
			else  {
				getToolkit().beep();
				/*funktio.setText(lasku);*/
				lue2.setText(""+solv.error_msg);
			}
		}
	}

	public void mouseExited(MouseEvent tapahtuma){}

	public final Color annaVari() {
		Color varivast = Color.black;
		if (rotaatio == 0)
			varivast = new Color(0,0,255);		
		else if (rotaatio == 1)
			varivast = new Color(20,200,20);		
		else if (rotaatio == 2)
			varivast = Color.gray;
		else if (rotaatio == 3)
			varivast = new Color(0,200,200);
		else if (rotaatio == 4)
			varivast = Color.red;
		else if (rotaatio == 5)
			varivast = new Color(200,200,0);	
		if (rotaatio == 5)
			rotaatio = 0;
		else rotaatio = rotaatio + 1;
		return varivast;
	}

	public final void muutaArvoja() {
		int laskin;
		raami.removeAll();
		raami.setBackground(new Color(204,204,255));
		Panel tekstit = new Panel(new GridLayout(solv.max_comp+1,1));
		Panel ruksit = new Panel(new GridLayout(solv.max_comp+1,1));
		Panel kentat = new Panel(new GridLayout(solv.max_comp+1,1));
		Panel yarvot = new Panel(new GridLayout(solv.components+2,2));
		tekstit.add(tteksti);
		kentat.add(tsyote);
		ruksit.add(muutat);
		for (laskin = 0 ; laskin < solv.components; laskin ++) {
			yarvosyote[laskin] = new TextField(10);
			valitsey[laskin] = new Checkbox("",true);
			tekstit.add(new Label("y" + laskin +"=", Label.RIGHT));
			ruksit.add(valitsey[laskin]);
			kentat.add(yarvosyote[laskin]);
		}
		for (laskin = solv.components; laskin < solv.max_comp; laskin++) {
			valitsey[laskin] = new Checkbox("",false);
			yarvosyote[laskin] = new TextField(10);
			valitsey[laskin].setEnabled(false);
			yarvosyote[laskin].setBackground(nappi);
			yarvosyote[laskin].setEditable(false);
			tekstit.add(new Label("y" + laskin +"=", Label.RIGHT));
			ruksit.add(valitsey[laskin]);
			kentat.add(yarvosyote[laskin]);
		}
		initialots.setFont(otsikkofontti);
		muutat.setBackground(nappi);
		piirra.setBackground(nappi);
		/*napit.add(piirra);*/
		raami.add("North",initialots);
		raami.add("East",ruksit);
		raami.add("West",tekstit);
		raami.add("Center",kentat);
		raami.add("South",piirra);
		raami.validate();
	}
	
/*Faasiasteikkomuutos*/

	public final void faasiMuutos()
	{
		boolean ok = true;
		double testi1 = 0;
		double testi2 = 0;
		double testi3 = 0;
		double testi4 = 0;
		try
		{
			testi1=new Double(y0min.getText()).doubleValue();
			testi2=new Double(y0max.getText()).doubleValue();
			testi3=new Double(y1min.getText()).doubleValue();
			testi4=new Double(y1max.getText()).doubleValue();
		}
		catch (Exception e)
		{
			ok = false;
		}
		if (ok && (testi1 < testi2) && (testi3< testi4))
			{
			ftmin=testi1;
			ftmax=testi2;
			ftleveys=ftmax-ftmin;
			fymin=testi3;
			fymax=testi4;
			fyleveys=fymax-fymin;
			faasi.repaint();
			}
		else
		{
			getToolkit().beep();
			lue2.setText("Bad values");
		}	
		y0min.setText(""+ftmin);
		y0max.setText(""+ftmax);
		y1min.setText(""+fymin);
		y1max.setText(""+fymax);
	}
/*aikaasteikkomuutos*/

	public final void aikaMuutos()
	{
		boolean ok = true;
		double testi1 = 0;
		double testi2 = 0;
		double testi3 = 0;
		double testi4 = 0;
		try
		{
			testi1=new Double(tmink.getText()).doubleValue();
			testi2=new Double(tmaxk.getText()).doubleValue();
			testi3=new Double(ymink.getText()).doubleValue();
			testi4=new Double(ymaxk.getText()).doubleValue();
		}
		catch (Exception e)
		{
			ok = false;
		}
		if (ok && (testi1 < testi2) && (testi3< testi4))
			{
			tmin=testi1;
			tmax=testi2;
			ymin=testi3;
			ymax=testi4;
			tleveys=tmax-tmin;
			yleveys=ymax-ymin;
			paperi.repaint();
			}
		else
		{
			getToolkit().beep();
			lue2.setText("Bad values");
		}	
		tmink.setText(""+tmin);
		tmaxk.setText(""+tmax);
		ymink.setText(""+ymin);
		ymaxk.setText(""+ymax);
	}
/*Laske pisteet ja piirr molemmat kyrt*/
	public final void piirraMolemmat() {
		Color vari = annaVari();		
		pisteet(talku, ypisteet, lopput);
		kayrat.addElement(kayra);	
		faasikayrat.addElement(faasikayra);
		suoritaPiirto(vari);
		piirraFaasi(vari);
		pisteet(talku, ypisteet, alkut);
		kayrat.addElement(kayra);	
		faasikayrat.addElement(faasikayra);
		suoritaPiirto(vari);
		piirraFaasi(vari);		
	}

/*piirr aikakyr*/
	public final void suoritaPiirto(Color vari)
	{
		int laskuri2;
		Graphics g = paperi.getGraphics();
		for (laskuri2 = 0; laskuri2 < solv.components; laskuri2++) {
			g.setColor(new Color(0,0,0));
			g.drawOval(xMuutosruudulle(talku)-5,yMuutosruudulle(ypisteet[laskuri2])-5,10,10);
			g.setColor(vari);
			if (valitsey[laskuri2].getState()) {
				g.drawPolyline(kayra[laskuri2].xpoints,kayra[laskuri2].ypoints,kayra[laskuri2].npoints);
				vari=vari.darker();
				g.fillRect(kayra[laskuri2].xpoints[0]+5,kayra[laskuri2].ypoints[0]-5,20,13);
				g.setColor(new Color(255,255,255));
				g.drawString("y"+laskuri2,kayra[laskuri2].xpoints[0]+10,kayra[laskuri2].ypoints[0]+5);
			}
			else
				vari=vari.darker();
		}
	}
/*piirr faasi*/
	public final void piirraFaasi(Color vari)
	{				
		vari = vari.darker();
		Graphics g = faasi.getGraphics();
		g.setColor(new Color(0,0,0));
		g.drawOval(faasikayra[vpiirto].xpoints[0]-5,faasikayra[hpiirto].ypoints[0]-5,10,10);
		g.setColor(vari);
		if (faasikayra[hpiirto].npoints < faasikayra[vpiirto].npoints) 
			g.drawPolyline(faasikayra[vpiirto].xpoints,faasikayra[hpiirto].ypoints,faasikayra[hpiirto].npoints);
		else 
			g.drawPolyline(faasikayra[vpiirto].xpoints,faasikayra[hpiirto].ypoints,faasikayra[vpiirto].npoints);
	}

/*koordinaatistomuunnokset*/
	public final double xMuutosruudulta(int ruutux)
	{
		double oikeax;
		oikeax = tmin+(tleveys/leveys)*(ruutux-reunus);
		return oikeax;
	}

	public final double yMuutosruudulta(int ruutuy)
	{
		double oikeay;
		oikeay = ymin+yleveys+yleveys/korkeus*(-ruutuy+reunus);
		return oikeay;
	}

	public final int xMuutosruudulle(double oikeax)
	{
		int ruutux;
		ruutux = ((int)(reunus+(leveys*(oikeax-tmin)/tleveys)));
		return ruutux;
	}

	public final int yMuutosruudulle(double oikeay)
	{
		int ruutuy;		
		ruutuy = ((int)(reunus+korkeus-(korkeus*(oikeay-ymin)/yleveys)));
		return ruutuy;
	}
	public final double fxMuutosruudulta(int ruutux)
	{
		double oikeax;
		oikeax = ftmin+(ftleveys/fleveys)*(ruutux-reunus);
		return oikeax;
	}

	public final double fyMuutosruudulta(int ruutuy)
	{
		double oikeay;
		oikeay = fymin+fyleveys+fyleveys/fleveys*(-ruutuy+reunus);
		return oikeay;
	}

	public final int fxMuutosruudulle(double oikeax)
	{
		int ruutux;
		ruutux = ((int)(reunus+fleveys*(oikeax-ftmin)/ftleveys));
		return ruutux;
	}

	public final int fyMuutosruudulle(double oikeay)
	{
		int ruutuy;
		ruutuy = ((int)(reunus+fleveys-fleveys*(oikeay-fymin)/fyleveys));
		return ruutuy;
	}



	public final void pisteet(double t0, double[] y, double thuippu) {
		double[] s1;
		double[] s2;
		double[] s3;
		double[] s4;	
		double t = t0;	
		double delta=0, tau;
		double tol = 0.00001;
		double hmax = Math.abs(thuippu - t)/5;
		double hmin = Math.abs(thuippu - t)/20000;
		double h = (thuippu-t)/100;
		double maxy = 0;
		double htemp=0;
		int suunta = 1;
		int laskin;
		boolean askelok = true;
		boolean keskeyta=false;

		kayra = new Polygon[solv.components];
		faasikayra = new Polygon[solv.components];
		for (laskin = 0; laskin < solv.components; laskin++) {
			kayra[laskin]=new Polygon();
			kayra[laskin].addPoint(xMuutosruudulle(t),yMuutosruudulle(y[laskin]));		
			faasikayra[laskin]=new Polygon();
			faasikayra[laskin].addPoint(fxMuutosruudulle(y[laskin]),fyMuutosruudulle(y[laskin]));
			if (Math.abs(y[laskin]) > maxy)
				maxy = Math.abs(y[laskin]);		
		}
		int laskalg = algoritmi.getSelectedIndex();
		switch (laskalg) {
			case 0 : /*adaptiivinen*/
				while ((Math.abs(t - thuippu) > 0) && (Math.abs(h) >= hmin) && (keskeyta == false)){
					if (((h > 0) && (t + h > thuippu)) || ((h < 0) && (t + h < thuippu)))
						h = thuippu - t;
      				s1 = solv.evaluate(t, y);
      				s2 = solv.evaluate(t+h, vplusv(y,skertv(h,s1)));
      				s3 = solv.evaluate(t+h/2, vplusv(y,skertv((h/4.0),(vplusv(s1,s2)))));
					s4 = skertv((h/3.0),(vplusv(vplusv(s1,skertv(-2.0,s3)),s2)));
					if (solv.error == false) {
						tau = tol * Math.max(maxy, 1);
						delta = 0;
						for (laskin = 0; laskin < s1.length; laskin++){
							if (Math.abs(s4[laskin]) > delta);
							delta = Math.abs(s4[laskin]);
						}
						if (delta <= tau){
							t += h;
    	     				y = vplusv(y,skertv((h/6),(vplusv(vplusv(s1,skertv(4,s3)),s2))));
							maxy =0;
							for (laskin = 0; laskin < solv.components; laskin++) {
								if (Math.abs(y[laskin]) > maxy)
									maxy = Math.abs(y[laskin]);
							}
							for (laskin = 0; laskin < solv.components; laskin++) {
								if (((y[laskin] < ymax+2*yleveys) && (y[laskin] > ymin-2*yleveys)) || ((y[laskin] < Math.max(fymax+2*fyleveys,ftmax+2*ftleveys)) && (y[laskin] > Math.min(fymin-2*fyleveys,ftmin-2*ftleveys)))) {
									kayra[laskin].addPoint(xMuutosruudulle(t),yMuutosruudulle(y[laskin]));
									faasikayra[laskin].addPoint(fxMuutosruudulle(y[laskin]),fyMuutosruudulle(y[laskin]));
								}
							}
							h *= 1.1;
						}
						else h *= 0.9;
					}
					else keskeyta=true;
				}
				break;
			case 1 : /*euler*/
				try {
					htemp=new Double(askel.getText()).doubleValue();
				}
				catch (Exception e) {
					askelok = false;
				}
				if (askelok)
					askelpituus = htemp;
				h = askelpituus;
				if ((thuippu - t) < 0) {
					h = -h;
					suunta = -1;
				}
				while ((suunta*(thuippu-t) > 0) && keskeyta == false) {
					y = vplusv(y,skertv(h,solv.evaluate(t, y)));
					t += h;
					if (solv.error == false) {
						for (laskin = 0; laskin < solv.components; laskin++) {
							if (((y[laskin] < 2*ymax-ymin) && (y[laskin] > 2*ymin-ymax)) || ((y[laskin] < Math.max(fymax+2*fyleveys,ftmax+2*ftleveys)) && (y[laskin] > Math.min(fymin-2*fyleveys,ftmin-2*ftleveys)))) {
								kayra[laskin].addPoint(xMuutosruudulle(t),yMuutosruudulle(y[laskin]));
								faasikayra[laskin].addPoint(fxMuutosruudulle(y[laskin]),fyMuutosruudulle(y[laskin]));
							}
							else keskeyta=true;
						}
					}
					else keskeyta=true;
				}
				break;
			case 2 :
				try {
					htemp=new Double(askel.getText()).doubleValue();
				}
				catch (Exception e) {
					askelok = false;
				}
				if (askelok)
					askelpituus = htemp;
				h = askelpituus;
				if ((thuippu - t) < 0) {
					h = -h;
					suunta = -1;
				}
				while ((suunta*(thuippu-t) > 0) && keskeyta) {
					y = vplusv(y,skertv(h/2,(vplusv(solv.evaluate(t,y),solv.evaluate(t+h,vplusv(y,skertv(h,solv.evaluate(t,y))))))));
					t += h;
					if (solv.error == false) {
						for (laskin = 0; laskin < solv.components; laskin++) {
							if (((y[laskin] < 2*ymax-ymin) && (y[laskin] > 2*ymin-ymax)) || ((y[laskin] < Math.max(fymax+2*fyleveys,ftmax+2*ftleveys)) && (y[laskin] > Math.min(fymin-2*fyleveys,ftmin-2*ftleveys)))) {
								kayra[laskin].addPoint(xMuutosruudulle(t),yMuutosruudulle(y[laskin]));
								faasikayra[laskin].addPoint(fxMuutosruudulle(y[laskin]),fyMuutosruudulle(y[laskin]));
							}
							else keskeyta=true;
						}
					}
					else keskeyta=true;
				}

				break;
			case 3 : /*runge-kutta*/
				try {
					htemp=new Double(askel.getText()).doubleValue();
				}
				catch (Exception e) {
					askelok = false;
				}
				if (askelok)
					askelpituus = htemp;
				h = askelpituus;
				if ((thuippu - t) < 0) {
					h = -h;
					suunta = -1;
				}
				while ((suunta*(thuippu-t) > 0) && keskeyta == false) {
					s1 = skertv(h,solv.evaluate(t,y));
					s2 = skertv(h,solv.evaluate(t+h/2,vplusv(y,skertv(1/2.0,s1))));
					s3 = skertv(h,solv.evaluate(t+h/2,vplusv(y,skertv(1/2.0,s2))));
					s4 = skertv(h,solv.evaluate(t+h,vplusv(y,s3)));
					y = vplusv(y,skertv(1/6.0,vplusv(s1,vplusv(skertv(2,s2),vplusv(skertv(2,s3),s4)))));
					t += h;
					if (solv.error == false) {
						for (laskin = 0; laskin < solv.components; laskin++) {
							if (((y[laskin] < 2*ymax-ymin) && (y[laskin] > 2*ymin-ymax)) || ((y[laskin] < Math.max(fymax+2*fyleveys,ftmax+2*ftleveys)) && (y[laskin] > Math.min(fymin-2*fyleveys,ftmin-2*ftleveys)))) {
								kayra[laskin].addPoint(xMuutosruudulle(t),yMuutosruudulle(y[laskin]));
								faasikayra[laskin].addPoint(fxMuutosruudulle(y[laskin]),fyMuutosruudulle(y[laskin]));
							}
							else keskeyta=true;
						}
					}
					else keskeyta=true;
				}
				break;
			case 4 : /*adams-bashforth*/
				int lask;
				Vector arvot = new Vector();
				try {
					htemp=new Double(askel.getText()).doubleValue();
				}
				catch (Exception e) {
					askelok = false;
				}
				if (askelok)
					askelpituus = htemp;
				h = askelpituus;
				if ((thuippu - t) < 0) {
					h = -h;
					suunta = -1;
				}
				for (lask=0; lask < 4; lask++) {
					s1 = skertv(h,solv.evaluate(t,y));
					s2 = skertv(h,solv.evaluate(t+h/2,vplusv(y,skertv(1/2.0,s1))));
					s3 = skertv(h,solv.evaluate(t+h/2,vplusv(y,skertv(1/2.0,s2))));
					s4 = skertv(h,solv.evaluate(t+h,vplusv(y,s3)));
					y = vplusv(y,skertv(1/6.0,vplusv(s1,vplusv(skertv(2,s2),vplusv(skertv(2,s3),s4)))));
					t += h;
					arvot.addElement(y);
					if (solv.error == false) {
						for (laskin = 0; laskin < solv.components; laskin++) {
							if (((y[laskin] < 2*ymax-ymin) && (y[laskin] > 2*ymin-ymax)) || ((y[laskin] < Math.max(fymax+2*fyleveys,ftmax+2*ftleveys)) && (y[laskin] > Math.min(fymin-2*fyleveys,ftmin-2*ftleveys)))) {
								kayra[laskin].addPoint(xMuutosruudulle(t),yMuutosruudulle(y[laskin]));
								faasikayra[laskin].addPoint(fxMuutosruudulle(y[laskin]),fyMuutosruudulle(y[laskin]));
							}
							else keskeyta=true;
						}
					}
					else keskeyta=true;
				}
				while ((suunta*(thuippu-t) > 0) && keskeyta == false) {
					y = vplusv(y,skertv(h/24,vplusv(vplusv(vplusv(skertv(55,solv.evaluate(t,(double[])arvot.elementAt(3))),skertv(-59,solv.evaluate(t-h,(double[])arvot.elementAt(2)))),skertv(37,solv.evaluate(t-h*2,(double[])arvot.elementAt(1)))),skertv(-9,solv.evaluate(t-h*3,(double[])arvot.elementAt(0))))));
					t = t + h;
					arvot.setElementAt(arvot.elementAt(1),0);
					arvot.setElementAt(arvot.elementAt(2),1);
					arvot.setElementAt(arvot.elementAt(3),2);
					arvot.setElementAt(y,3);
					if (solv.error == false) {
						for (laskin = 0; laskin < solv.components; laskin++) {
							if (((y[laskin] < 2*ymax-ymin) && (y[laskin] > 2*ymin-ymax)) || ((y[laskin] < Math.max(fymax+2*fyleveys,ftmax+2*ftleveys)) && (y[laskin] > Math.min(fymin-2*fyleveys,ftmin-2*ftleveys)))) {
								kayra[laskin].addPoint(xMuutosruudulle(t),yMuutosruudulle(y[laskin]));
								faasikayra[laskin].addPoint(fxMuutosruudulle(y[laskin]),fyMuutosruudulle(y[laskin]));
							}
							else keskeyta=true;
						}
					}
					else keskeyta=true;
		}


				break;
		}
	}

	public final double[] vplusv(double[] eka, double[] toka)
	{
		int laskin;
		double[] vastaus = new double[eka.length];
		for (laskin = 0; laskin < eka.length; laskin++)
			vastaus[laskin]=eka[laskin]+toka[laskin];
		return vastaus;
	}
	
	public final double[] skertv(double kert, double[] eka)
	{
		int laskin;
		double[] vastaus = new double[eka.length];
		for (laskin = 0; laskin < eka.length; laskin++)
			vastaus[laskin]=kert*eka[laskin];
		return vastaus;
	}
/*aikataso*/				
public final class Piirtoalusta extends Canvas {
	public void paint(Graphics g) {
		int xtemp, ytemp;
		int laskuri2, laskin;
		double alku;
		double x;
		double askelx,askely;
		Color vari;
		int ymuutosmin=yMuutosruudulle(ymin);
		int ymuutosmax=yMuutosruudulle(ymax);
		int xmuutosmin=xMuutosruudulle(tmin);
		int xmuutosmax=xMuutosruudulle(tmax);
		askely = 0.0001;
		lue2.setText("Wait");
		if (tmax-tmin <= 10) {
			askelx = 1;
			while ((tleveys/askelx) < 8)
				askelx /= 2;
		}
		else {
			askelx = 0.5;	
			while ((tleveys/askelx) > 10)
				askelx += 0.5;
		}
		if (ymax-ymin <= 10) {
			askely = 1;
			while ((yleveys/askely) < 8)
				askely /= 2;
		}
		else {
			askely = 0.5;
			while ((yleveys/askely) > 10)
				askely += 0.5;
		}
		g.setColor(asteikkovari);
		g.drawRect(reunus,reunus,leveys,korkeus);
		if (tmax >= 0) {
			if (tmin > 0)
				alku = tmin;
			else alku = 0;
			for (x = alku; x <= tmax;x += askelx) {
				g.setColor(asteikkovari);
				xtemp = xMuutosruudulle(x);
				g.drawLine(xtemp, ymuutosmax,xtemp,ymuutosmin);
				g.setColor(numvari);
				g.drawString(""+ x,xtemp-10,ymuutosmin+15);
			}
		}
		if (tmin < 0) {
			if (tmax < 0)
				alku = tmax;
			else 
				alku = askelx;
			for (x = alku; x <= -tmin; x += askelx) {
				g.setColor(asteikkovari);
				xtemp = xMuutosruudulle(-x);
				g.drawLine(xtemp,ymuutosmax,xtemp,ymuutosmin);
				g.setColor(numvari);
				g.drawString(""+ (-x),xtemp-10,ymuutosmin+15);
			}
		}
		if (ymax >= 0) {
			if (ymin > 0)
				alku = ymin;
			else
				alku = 0;
			for (x = alku; x <= ymax;x+=askely) {	
				g.setColor(asteikkovari);
				ytemp = yMuutosruudulle(x);
				g.drawLine(xmuutosmin, ytemp,xmuutosmax,ytemp);
				g.setColor(numvari);
				g.drawString(""+ x,xmuutosmin-22,ytemp+5);
			}			
		}
		if (ymin < 0) {
			if (ymax < 0)
				alku = ymax;
			else
				alku = askely;
			for (x = alku; x <= -ymin; x+=askely) {
				g.setColor(asteikkovari);
				ytemp = yMuutosruudulle(-x);
				g.drawLine(xmuutosmin, ytemp,xmuutosmax,ytemp);
				g.setColor(numvari);
				g.drawString(""+ (-x),xmuutosmin-22,ytemp+5);
			}
		}
		if (kayrat.size()>0) {
			rotaatio=0;
			boolean varilask=true;
			Color varitemp=Color.black;
			vari=Color.black;
			for (laskin = 0; laskin < kayrat.size(); laskin++) {
				if (varilask==true) {
					vari=annaVari();
					varilask = false;
				}
				else
					varilask = true;
				varitemp=vari;
				kayra = (Polygon[])kayrat.elementAt(laskin);
				for (laskuri2 = 0; laskuri2 < solv.components; laskuri2++) {
					g.setColor(Color.black);
					g.drawOval(kayra[laskuri2].xpoints[0]-5,kayra[laskuri2].ypoints[0]-5,10,10);
					g.setColor(varitemp);
					g.drawPolyline(kayra[laskuri2].xpoints,kayra[laskuri2].ypoints,kayra[laskuri2].npoints);
					varitemp=varitemp.darker();
					g.fillRect(kayra[laskuri2].xpoints[0]+5,kayra[laskuri2].ypoints[0]-5,20,13);
					g.setColor(new Color(255,255,255));
					g.drawString("y"+laskuri2,kayra[laskuri2].xpoints[0]+10,kayra[laskuri2].ypoints[0]+5);

				}
			}
		}
		g.setFont(otsikkofontti);
		g.setColor(Color.black);
		g.drawString("Time dependence",0,reunus/2);
		lue2.setText("Ready");
	}
}

/*Faasiluokka*/
public final class Faasialusta extends Canvas{
	public final void paint(Graphics g){
		double alku;
		int laskuri2, laskin=0;
		double x;
		double askelx,askely=0.0001;
		int xtemp, ytemp;
		int fxmuutosmax=fxMuutosruudulle(ftmax);
		int fxmuutosmin=fxMuutosruudulle(ftmin);
		int fymuutosmax=fyMuutosruudulle(fymax);
		int fymuutosmin=fyMuutosruudulle(fymin);
		double skxkoord,skykoord;
		Color vari;
		double[] ysuunta= new double[2];
		double skx0,sky0,skx1,sky1,yksx,yksy,pituus,kx,ky;
		double skpituus = 8;
		double skxaskel = (ftleveys) / 15;
		double skyaskel = (fyleveys) / 15;
		double[] suunta = new double[2];
		double kpit = 8; /*Suuntakenttnuolen poikkiviivan pituus*/
		lue2.setText("Wait");
/*asteikko*/
		if (ftleveys <= 10){
			askelx = 1;
			while ((ftleveys/askelx) < 8)
				askelx = askelx/2;
		}
		else {
			askelx = 0.5;	
			while ((ftleveys/askelx) > 10)
				askelx = askelx + 0.5;
		}
		if (fyleveys <= 10) {
			askely = 1;
			while ((fyleveys/askely) < 8)
				askely = askely/2;
		}
		else {
			askely = 0.5;
			while ((fyleveys/askely) > 10)
				askely = askely + 0.5;
		}
		g.setColor(asteikkovari);
		g.drawRect(reunus,reunus,fleveys,fleveys);
		if (ftmax >= 0) {
			if (ftmin > 0)
				alku = tmin;
			else
				alku = 0;
			for (x = alku; x <= ftmax;x+=askelx) {
				g.setColor(asteikkovari);
				xtemp = fxMuutosruudulle(x);
				g.drawLine(xtemp, fymuutosmax,xtemp,fymuutosmin);
				g.setColor(numvari);
				g.drawString(""+ x,xtemp-10,fymuutosmin+15);
			}
		}
		if (ftmin < 0) {
			if (ftmax < 0)
				alku = ftmax;
			else
				alku = askelx;
			for (x = alku; x <= -ftmin; x += askelx) {
				g.setColor(asteikkovari);
				xtemp = fxMuutosruudulle(-x);
				g.drawLine(xtemp,fymuutosmax,xtemp,fymuutosmin);
				g.setColor(numvari);
				g.drawString(""+ (-x),xtemp-10,fymuutosmin+15);
			}
		}
		if (fymax >= 0) {
			if (fymin > 0) alku = fymin;
				else alku = 0;
			for (x = alku; x <= fymax;x+=askely) {	
				g.setColor(asteikkovari);
				ytemp = fyMuutosruudulle(x);
				g.drawLine(fxmuutosmin, ytemp,fxmuutosmax,ytemp);
				g.setColor(numvari);
				g.drawString(""+ x,fxmuutosmin-22,ytemp+5);
			}			
		}
		if (fymin < 0) {
			if (fymax < 0)
				alku = fymax;
			else
				alku = askely;
			for (x = alku; x <= -fymin; x += askely) {
				g.setColor(asteikkovari);
				ytemp = fyMuutosruudulle(-x);
				g.drawLine(fxmuutosmin, ytemp,fxmuutosmax,ytemp);
				g.setColor(numvari);
				g.drawString(""+ (-x),fxmuutosmin-22,ytemp+5);
			}
		}
		/*suuntakentt*/
		if (solv.components == 2){ 
			g.setColor(suuntavari);
			for (skxkoord = ftmin+skxaskel; skxkoord <= ftmax-skxaskel; skxkoord += skxaskel) {
				for (skykoord = fymin+skyaskel; skykoord <= fymax-skyaskel; skykoord += skyaskel){
					ysuunta[0] = skxkoord;
					ysuunta[1] = skykoord;
					suunta = solv.evaluate(talku,ysuunta);
					if (solv.error == false) {
						skx0 = (double)fxMuutosruudulle(skxkoord);
						sky0 = (double)fyMuutosruudulle(skykoord);
						skx1 = (double)fxMuutosruudulle(skxkoord+suunta[0]);
						sky1 = (double)fyMuutosruudulle(skykoord+suunta[1]);
						pituus = (double)skpituus/Math.sqrt(Math.pow(skx1-skx0,2)+Math.pow(sky1-sky0,2));
						yksx = (double)(skx1-skx0)*pituus;
						yksy = (double)(sky1-sky0)*pituus;
						ky=Math.sqrt(kpit/(Math.pow(yksy/yksx,2)+1));
						kx=-yksy*ky/yksx;
						g.drawLine((int)skx0,(int)sky0,(int)(skx0+yksx),(int)(sky0+yksy));
						g.drawLine((int)skx0,(int)sky0,(int)(skx0-yksx),(int)(sky0-yksy));	
						g.drawLine((int)skx0,(int)sky0,(int)(skx0+kx),(int)(sky0+ky));
						g.drawLine((int)skx0,(int)sky0,(int)(skx0-kx),(int)(sky0-ky));
						g.drawLine((int)(skx0+kx),(int)(sky0+ky),(int)(skx0+yksx),(int)(sky0+yksy));
						g.drawLine((int)(skx0-kx),(int)(sky0-ky),(int)(skx0+yksx),(int)(sky0+yksy));
					}
					else {
						solv.error = false;
					}
					laskin++;
				}
			}
		}		
			/*piirr faasikyrt*/			
		if (faasikayrat.size()>0) {
			rotaatio=0;
			boolean varilask=true;
			Color varitemp=Color.black;
			vari=Color.black;
			for (laskin = 0; laskin < faasikayrat.size(); laskin++) {
				if (varilask==true) {
					vari=annaVari();
					varilask = false;
				}
				else
					varilask = true;
				varitemp=vari;
				faasikayra = (Polygon[])faasikayrat.elementAt(laskin);
				for (laskuri2 = 0; laskuri2 < solv.components; laskuri2++) {
					g.setColor(new Color(0,0,0));
					g.drawOval(faasikayra[vpiirto].xpoints[0]-5,faasikayra[hpiirto].ypoints[0]-5,10,10);
					g.setColor(varitemp);
					varitemp=varitemp.darker();
					g.drawPolyline(faasikayra[vpiirto].xpoints,faasikayra[hpiirto].ypoints,faasikayra[hpiirto].npoints);
				}
			}
		}
		g.setFont(otsikkofontti);
		g.setColor(Color.black);
		g.drawString("Phase plane",0,reunus/2);
		lue2.setText("Ready");
	}
}
}
